# $Revision: 1.41 $, $Date: 2010/02/22 18:26:15 $
# 4.8 makes libpthread a hard requirement
# 4.7 has a heavier footprint
%define		db_version	4.6.21

%define		subver		pre1
%define		rel			11
Summary:	Berkeley DB Name Service Switch Module
Summary(pl.UTF-8):	Moduł NSS do baz db
Name:		nss_db
Version:	2.2.3
Release:	0.%{subver}.%{rel}
# DB is under the Sleepycat (Oracle) license.
# nss_db is under the LGPLv2+ license.
License:	Sleepycat and LGPL v2+
Group:		Base
Source0:	ftp://sources.redhat.com/pub/glibc/old-releases/%{name}-%{version}%{subver}.tar.gz
# Source0-md5:	b4440ba2865d28e9068e465426c19ede
Source1:	http://download.oracle.com/berkeley-db/db-%{db_version}.tar.gz
# Source1-md5:	718082e7e35fc48478a2334b0bc4cd11
Patch0:		%{name}-chmod_644.patch
Patch1:		%{name}-amfix.patch
Patch2:		%{name}-glibc23.patch
Patch3:		%{name}-db41.patch
Patch4:		%{name}-errno.patch
Patch5:		%{name}-link.patch
Patch6:		%{name}-enoent.patch
Patch7:		%{name}-uniqdb.patch
Patch8:		%{name}-initialize.patch
Patch9:		%{name}-selinux.patch
Patch10:	%{name}-makedb-atomic.patch
Patch101:	http://www.oracle.com/technology/products/berkeley-db/db/update/4.6.21/patch.4.6.21.1
Patch102:	http://www.oracle.com/technology/products/berkeley-db/db/update/4.6.21/patch.4.6.21.2
Patch103:	http://www.oracle.com/technology/products/berkeley-db/db/update/4.6.21/patch.4.6.21.3
Patch104:	http://www.oracle.com/technology/products/berkeley-db/db/update/4.6.21/patch.4.6.21.4
BuildRequires:	autoconf
BuildRequires:	automake >= 1.4
BuildRequires:	gettext-devel
BuildRequires:	glibc-devel >= 2.3
BuildRequires:	libselinux-devel
BuildRequires:	libtool
Requires:	glibc >= 6:2.3
Requires:	make
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# private symbols
%define		_noautoprov		.*\(GLIBC_PRIVATE\)
%define		_noautoreq		.*\(GLIBC_PRIVATE\)

%description
This is nss_db, a name service switch module that can be used with
glibc-2.2.x.

%description -l pl.UTF-8
To jest nss_db, moduł do serwisu nazw, który może być używany z
glibc-2.2.x.

%prep
%setup -q -n %{name}-%{version}%{subver} -a1
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1

mkdir db-build
cd db-%{db_version}
%patch101 -p0
%patch102 -p0
%patch103 -p0
%patch104 -p0

%build
dbdir=$(pwd)/db-instroot
cd db-build

CC="%{__cc}"
CXX="%{__cxx}"
CFLAGS="%{rpmcflags}"
CXXFLAGS="%{rpmcflags} -fno-implicit-templates"
LDFLAGS="%{rpmcflags} %{rpmldflags}"
export CC CXX CFLAGS CXXFLAGS LDFLAGS

echo db_cv_mutex=UNIX/fcntl > config.cache
../db-%{db_version}/dist/configure -C \
	--disable-compat185 \
	--disable-cxx \
	--disable-diagnostic \
	--disable-dump185 \
	--disable-java \
	--disable-rpc \
	--disable-tcl \
	--disable-shared \
	--disable-cryptography \
	--disable-hash \
	--disable-queue \
	--disable-replication \
	--disable-statistics \
	--disable-verify \
	--with-pic \
	--with-uniquename=_nssdb \
	--prefix=$dbdir \
	--libdir=$dbdir/lib
%{__make}
%{__make} install
cd ..

%{__gettextize}
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--with-db=${dbdir} \
	--with-selinux

%{__make} \
	slibdir=/%{_lib}

# Check for any problems, since we filter GLIBC_PRIVATE provs
# in glibc package and deps here
cat >> test-dlopen.c << _EOF
#include <dlfcn.h>
/* Simple program to see if dlopen() would succeed. */
int main(int argc, char **argv)
{
	if (dlopen(argv[1], RTLD_NOW))
		return 0;
	return 1;
}
_EOF

%{__cc} %{rpmcflags} -o test-dlopen test-dlopen.c -ldl

./test-dlopen src/.libs/libnss_db.so.2.0.0

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/%{_lib},/var/db}

%{__make} install \
	slibdir=/%{_lib} \
	DESTDIR=$RPM_BUILD_ROOT

rm $RPM_BUILD_ROOT%{_libdir}/libnss_db.so
cp -a db-Makefile $RPM_BUILD_ROOT/var/db/Makefile

cat << EOF -> $RPM_BUILD_ROOT%{_bindir}/create-db
#!/bin/sh
%{__make} -sC /var/db
EOF

ln -sf create-db $RPM_BUILD_ROOT%{_bindir}/update-db

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog NEWS README THANKS
%attr(755,root,root) /%{_lib}/libnss_db-*.so
%attr(755,root,root) %ghost /%{_lib}/libnss_db.so.2
%attr(755,root,root) %{_bindir}/create-db
%attr(755,root,root) %{_bindir}/makedb
%attr(755,root,root) %{_bindir}/update-db

%config(noreplace) %verify(not md5 mtime size) /var/db/Makefile

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: nss_db.spec,v $
Revision 1.41  2010/02/22 18:26:15  glen
- release 11

Revision 1.40  2010/02/22 17:36:13  glen
- add -makedb-atomic.patch from fc/centos

Revision 1.39  2010/02/22 17:13:23  glen
- update berkdb to 4.6.21.4
- more specific license
- glibc epoch
- disable cryptography, hash, queue, replication, statistics, verify from db build
- ghost soname symlink
- verbose files
- rel 10

Revision 1.38  2008/12/06 19:25:42  baggins
- rel .9
- filter out GLIBC_PRIVATE deps/provs but check if compiled library
  loads correctly

Revision 1.37  2008/11/18 09:08:09  arekm
- rel .8

Revision 1.36  2007/10/10 15:18:39  baggins
- removed BR: db-devel

Revision 1.35  2007/10/10 15:17:09  baggins
- rel .7
- build with private copy of libdb (BAD things happen when linked
  with system db, like static programs suddenly sigsegving)
- added selinux support for makedb
- some bugfixes from FC (descriptions in patches)

Revision 1.34  2007/09/05 14:50:21  baggins
- rel 6

Revision 1.33  2007/02/13 07:16:49  glen
- tabs in preamble

Revision 1.32  2007/02/12 00:49:13  baggins
- converted to UTF-8

Revision 1.31  2005/12/13 13:58:51  glen
- adapterized (sorted %verify attrs)

Revision 1.30  2005/12/05 23:15:47  baggins
- rel .5
- config noreplace for the Makefile

Revision 1.29  2005/12/05 20:49:57  baggins
- rel 4
- fixed linking

Revision 1.28  2004/08/16 05:29:09  ankry
- rel. .3

Revision 1.27  2004/08/16 04:25:42  arekm
- do not use glibc private symbols

Revision 1.26  2004/04/02 22:20:55  qboosh
- release .2

Revision 1.25  2004/04/02 22:14:08  qboosh
- pass slibdir, not only sparc64 uses lib64

Revision 1.24  2004/04/02 22:03:33  qboosh
- updated to 2.2.3pre1
- updated amfix patch, added glibc23,db41 patches - builds now

Revision 1.23  2003/12/27 18:11:50  yoshi
- Added missing br: libstdc gcc-c++ lwp-devel, however as it still doesn't
  build (/usr/include/bits/libc-lock.h:27:36: linuxthreads/internals.h: No
  such file or directory) theye are now commented.

Revision 1.22  2003/06/06 06:08:21  ankry
- cosmetics

Revision 1.21  2003/05/28 12:59:55  malekith
- massive attack: source-md5

Revision 1.20  2003/05/25 05:51:13  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.19  2003/04/16 11:15:54  radek
- s/db3-devel/db-devel/

Revision 1.18  2002/11/27 22:06:25  juandon
- new %doc

Revision 1.17  2002/10/09 13:14:41  kloczek
- use more macros, some cosmetics, added missing "rm -f missing" and use new %doc

Revision 1.16  2002/06/23 20:32:32  kloczek
- perl -pi -e "s/^libtoolize --copy --force/\%\{__libtoolize\}/"

Revision 1.15  2002/05/21 23:14:15  kloczek
- perl -pi -e "s/^automake -a -c -f --foreing/\%\{__automake\}/; \
             s/^automake -a -c -f/\%\{__automake\}/; \
     s/^autoconf/\%\{__autoconf\}/"

Revision 1.14  2002/03/24 23:28:22  kloczek
- perl -pi -e "s/^automake -a -c$/automake -a -c -f/"

Revision 1.13  2002/02/23 04:05:42  kloczek
- adapterized.

Revision 1.12  2002/02/22 23:29:20  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.11  2002/01/18 02:14:03  kloczek
- perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.10  2001/10/20 16:50:33  qboosh
- release 8: amfix patch for automake 1.5

Revision 1.9  2001/09/18 20:27:04  blues
- rm -f missing added

Revision 1.8  2001/08/09 16:57:06  kloczek
- regenerate libtool in %build.

Revision 1.7  2001/08/09 16:48:27  kloczek
- release 7,
- security fix: shadow dadabase CAN'T be word readable - set permission to 640.

Revision 1.6  2001/02/11 19:48:39  kloczek
- added pl Summary.

Revision 1.5  2001/02/11 18:53:57  mkochano
- Release 2.
- Added patch making sure databases are world-readable.

Revision 1.4  2000/11/12 03:38:18  kloczek
- added Requires: glibc 2.2,
- added "BuildRequires: glibc-devel >= 2.2",
- do not striip binaries in %install.

Revision 1.3  2000/11/10 17:40:47  baggins
- updated to 2.2
- changed source URL

Revision 1.2  2000/10/03 22:10:00  kloczek
- typo in Source url.

Revision 1.1  2000/09/26 16:31:37  baggins
- initial revision
